#!/usr/bin/env python
# -*- coding: utf-8 -*-
# License:: GPL
# Author:: Alberto Milone (aka tseliot) (mailto:albertomilone@alice.it)
# Website:: http://albertomilone.com

import os, sys
import re

class EnvyParser:
    def __init__(self):
        self.file = '/etc/X11/xorg.conf'
        self.newdevices = ''
        self.newscreens = ''
##        self.wheredevices = []
##        self.wherescreens = []
        self.newlines = []
        self.lines = []
        self.sections = []
        self.endsections = []
        self.fullsections = []
        self.csections = {}
        self.devices = []
        self.screens = []
        self.extensions = []
        self.monitors = []
        self.serverflags = []
        self.serverlayouts = []
        self.nofile = False
        self.nocategory = False

        
    def operate(self):
        lines = []
        sections = []
        endsections = []
##        subsections = []
##        endsubsections = []
        csections = {}
##        csubsections = {}
        
        sections1 = []
        endsections1 = []
        
        fullsections = []
        
##        fullsubsections = []
        
        pat1 = re.compile('(.*)Section .*\".+\".*\n$')
        pat2 = re.compile('(.*)EndSection.*\n$')
##        pat3 = re.compile('(.*)SubSection .*\".+\".*\n$')
##        pat4 = re.compile('(.*)EndSubSection.*\n$')
        if not os.path.isfile(self.file):#NO XORG.conf FOUND
            self.nofile = True
        else:
            text = open(self.file, 'r')
            optext = text.readlines()
            it = 0
            for line in optext:
                m1 = pat1.match(line)
                m2 = pat2.match(line)
                lines.append(line)
    ##            m3 = pat3.match(line)
    ##            m4 = pat4.match(line)
                if m1:
                    if '#' and 'Sub' not in m1.group(1):
                        sections.append(it)
                        sections1.append(line)
    ##                elif '#' not in m1.group(1) and 'Sub' in m1.group(1):
    ##                    subsections.append(it)
                    #print line 
                elif m2:
                    if '#' not in m2.group(1):
                        endsections.append(it)
                        endsections1.append(line)
                    else:
                        if __name__ == '__main__':
                            print '*'*50, 'Discarded line:', line, '\n', '*'*50
                    #print line 
    ##            elif m3:
    ##                if '#' not in m3.group(1):
    ##                    subsections.append(it)
    ##                #print line 
    ##            elif m4:
    ##                if '#' not in m4.group(1):
    ##                    endsubsections.append(it)
    ##                #print line 
                it +=1
            
            
    ##        print 'Sections: ', str(sections)
            if __name__ == '__main__':
                print '*'*50, '\nSections:', str(len(sections1)), '\n', '*'*50, '\n', str(sections)
                print str(sections1)
                
                print '*'*50, '\nEndSections:', str(len(endsections1)), '\n', '*'*50, '\n', str(endsections)
                print str(endsections1)
    ##        print 'SubSections: ', str(subsections)
    ##        print 'EndSubSections: ', str(endsubsections)
                print len(sections)
                print len(endsections)
            
            iti = 0
            while iti != len(sections):
                csections[iti] = [sections[iti], endsections[iti]]
                iti +=1
            
            if __name__ == '__main__':
                print 'Complete Sections', str(csections), '\n'
            
            iter = 0
            
            for line in optext:
                iter1 = 0
                iter2 = 0
                #print 'iter', str(iter)
                for sec1 in csections:
                    if iter1 < len(csections):
                        if csections[iter1][0] <= iter <= csections[iter1][1]:
                            fullsections.append(line)
                    iter1 +=1
                iter +=1
            text.close()
            
            self.lines = lines
            self.sections = sections
            self.endsections = endsections
            self.fullsections = fullsections
            self.csections = csections
            #print 'Sections: \n', ''.join(fullsections)
    ##        print '\nSubSections: \n', ''.join(fullsubsections)

    def getdevice(self):
        devices = []
        iter = 0
        
        for line in self.lines:
            iter1 = 0
            for sec1 in self.csections:
                if iter1 < len(self.csections):
                    if self.csections[iter1][0] <= iter <= self.csections[iter1][1]:
                        if line.find('"Device"') != -1:
                            for elem in self.csections:
                                if self.csections[elem][0] == iter:
                                    devices.append(elem)
                            self.fullsections.append(line)
                iter1 +=1
            iter +=1
        if __name__ == '__main__':
            print 'Device is in self.csections:', str(devices)
        self.devices = devices
        
    def getscreen(self):
        screens = []
        iter = 0
        for line in self.lines:
            iter1 = 0
            for sec1 in self.csections:
                if iter1 < len(self.csections):
                    if self.csections[iter1][0] <= iter <= self.csections[iter1][1]:
                        if line.find('"Screen"') != -1:
                            for elem in self.csections:
                                if self.csections[elem][0] == iter:
                                    screens.append(elem)
                            self.fullsections.append(line)
                iter1 +=1
            iter +=1
        if __name__ == '__main__':
            print 'Screen is in self.csections:', str(screens)
        self.screens = screens
        
    def getextensions(self):
        screens = []
        iter = 0
        for line in self.lines:
            iter1 = 0
            for sec1 in self.csections:
                if iter1 < len(self.csections):
                    if self.csections[iter1][0] <= iter <= self.csections[iter1][1]:
                        if line.find('"Extensions"') != -1:
                            for elem in self.csections:
                                if self.csections[elem][0] == iter:
                                    screens.append(elem)
                            self.fullsections.append(line)
                iter1 +=1
            iter +=1
        if __name__ == '__main__':
            print 'Extensions is in self.csections:', str(screens)
        self.extensions = screens

    def getmonitors(self):
        screens = []
        iter = 0
        for line in self.lines:
            iter1 = 0
            for sec1 in self.csections:
                if iter1 < len(self.csections):
                    if self.csections[iter1][0] <= iter <= self.csections[iter1][1]:
                        if line.find('"Extensions"') != -1:
                            for elem in self.csections:
                                if self.csections[elem][0] == iter:
                                    screens.append(elem)
                            self.fullsections.append(line)
                iter1 +=1
            iter +=1
        if __name__ == '__main__':
            print 'Extensions is in self.csections:', str(screens)
        self.monitors = screens

    def getserverflags(self):
        screens = []
        iter = 0
        for line in self.lines:
            iter1 = 0
            for sec1 in self.csections:
                if iter1 < len(self.csections):
                    if self.csections[iter1][0] <= iter <= self.csections[iter1][1]:
                        if line.find('"Extensions"') != -1:
                            for elem in self.csections:
                                if self.csections[elem][0] == iter:
                                    screens.append(elem)
                            self.fullsections.append(line)
                iter1 +=1
            iter +=1
        if __name__ == '__main__':
            print 'Extensions is in self.csections:', str(screens)
        self.serverflags = screens
    
    def getserverlayouts(self):
        screens = []
        iter = 0
        for line in self.lines:
            iter1 = 0
            for sec1 in self.csections:
                if iter1 < len(self.csections):
                    if self.csections[iter1][0] <= iter <= self.csections[iter1][1]:
                        if line.find('"Extensions"') != -1:
                            for elem in self.csections:
                                if self.csections[elem][0] == iter:
                                    screens.append(elem)
                            self.fullsections.append(line)
                iter1 +=1
            iter +=1
        if __name__ == '__main__':
            print 'Extensions is in self.csections:', str(screens)
        self.serverlayouts = screens
        


    def addscreenoption(self, myoption, newoption, category):
        new = {}
        deviceslines = {}
        options = {}
        for dev in category:
            if __name__ == '__main__':
                print self.csections[dev][0]
                print self.csections[dev][1]
            a = self.lines[self.csections[dev][0]: self.csections[dev][-1]+1]
            deviceslines[dev] = a
        if __name__ == '__main__':
            print 'Devicelines', str(deviceslines)
            for n in deviceslines:
                print '*'*50, '\n', ''.join(deviceslines[n]), '\n', '*'*50, '\n'
        
        for i in deviceslines:
            new[i] = []
            for line in deviceslines[i]:
                #print 'Line is:', line
                #print elem
                if line.find(myoption) != -1:
                    if __name__ == '__main__':
                        print 'Option found (not appended):', line
                    line = newoption
                    new[i].append(line)
                else:
                    new[i].append(line)
        if __name__ == '__main__':
            print 'New:', str(new)
            print 'Csections:', str(self.csections)
            print 'Category:', str(category)
        
        if len(category) == 0:
            print 'ENVY PARSER: No category to modify'
            self.nocategory = True
        else:
            it = 0
            midit = 0
            
            a = category.index(category[0])
            dev = category[a]
            midit = 0
            while 1:
                if it < self.csections[category[0]][0]:
                    self.newlines.append(self.lines[it])
                    if __name__ == '__main__':
                        print '\nCase 1:', self.lines[it]
                        print 'IT', str(it)
                        print 'category[0][0]', str(self.csections[category[0]][0])
                        print 'DEV[0]', str(self.csections[dev][0])
                        print 'DEV', str(dev)
                    it +=1
                else:#ALL GREATER THAN 0[0]
                    if category.index(dev) < len(category):#IF NOT THE LAST ELEMENT
                        if self.csections[dev][0] <= it <= self.csections[dev][1]:#NEW(append line from new instead of self.lines)
                            if __name__ == '__main__':
                                print '\nCase 2:'
                                print 'IT', str(it), 'MIDIT', midit, 'LEN MIDIT', len(new[dev])
                                print 'DEV[0]', str(self.csections[dev][0])
                                print 'DEV[1]', str(self.csections[dev][1])
                                print 'DEV', str(dev)
                            
                            if midit <= len(new[dev]):
                                self.newlines.append(new[dev][midit])
                                if __name__ == '__main__':
                                    print 'NEW APPENDED (Case2)', new[dev][midit]
                                midit +=1
                            else:
                                midit = 0
                            it +=1
                        elif category.index(dev)+1 > len(category):
                            if self.csections[dev][1] <= it <= self.csections[category[category.index(dev)+1]][0]:#LIN(append plain line from self.lines)
                                self.newlines.append(self.lines[it])
                                if __name__ == '__main__':
                                    print '\nCase 3:', self.lines[it]
                                    print 'IT', str(it), 'MIDIT', midit, 'LEN MIDIT', len(new[dev])
                                    print 'DEV[0]', str(self.csections[dev][0])
                                    print 'DEV[1]', str(self.csections[dev][1])
                                    print 'DEV', str(dev)
                                it +=1
                            else:#useless?
                                if __name__ == '__main__':
                                    print 'Case 4:', str(category[category.index(dev)])
                                    print 'IT', it, 'MIDIT', midit, 'LEN MIDIT', len(new[dev])
                                    print 'DEV', str(dev)
                                self.newlines.append(self.lines[it])
                                it +=1
                                #print '\nCase 4:', self.lines[it]
                        else:
                            if it >= len(self.lines):#Finish
                                break
                            self.newlines.append(self.lines[it])#(append plain line from self.lines)
                            if __name__ == '__main__':
                                print '\nCase 5 (doesn\'t fit)', str(it), '\nline', str(self.lines[it])
                                print 'MIDIT', midit, 'LEN MIDIT', len(new[dev])
                                print 'DEV[0]', str(self.csections[dev][0])
                                print 'DEV[1]', str(self.csections[dev][1])
                                print 'DEV', str(dev)
                            it +=1
                            midit = 0
                            if category.index(dev)+1 < len(category):
                                if self.csections[category[a]+1][0] <= it <= self.csections[category[a]+1][1]:
                                    a +=1
                                    dev = category[a]


    def insscreenoption(self, newoption, category):
        new = {}
        deviceslines = {}
        options = {}
        if __name__ == '__main__':
            print '*'*50, '\n', str(self.devices), '\n', '*'*50, '\n'
        
        for dev in category:
            if __name__ == '__main__':
                print self.csections[dev][0]
                print self.csections[dev][1]
            a = self.lines[self.csections[dev][0]: self.csections[dev][-1]+1]
            if __name__ == '__main__':
                print ''.join(a), '\n'
            deviceslines[dev] = a
        if __name__ == '__main__':
            print 'Devicelines', str(deviceslines)
            for n in deviceslines:
                print '*'*50, '\n', ''.join(deviceslines[n]), '\n', '*'*50, '\n'
        for i in deviceslines:
            new[i] = []
            myit = 0
            for line in deviceslines[i]:
                #print 'Line is:', line
                #print elem
                if myit == len(deviceslines[i])-1:#in theory this should add the option before the last line# and deviceslines[i][0].find('Device') != -1
                    if __name__ == '__main__':
                        print 'Adding Option before this line:', line
                    new[i].append(newoption+line)
                    #new[i].append(line)
                else:
                    new[i].append(line)
                myit +=1
        if __name__ == '__main__':
            print 'New:', str(new)
            print 'Csections:', str(self.csections)
            print 'Category:', str(category)
        
        if len(category) == 0:
            print 'ENVY PARSER: No category to modify'
            self.nocategory = True
        else:
            it = 0
            midit = 0
            
            a = category.index(category[0])
            dev = category[a]
            midit = 0
            while 1:
                if it < self.csections[category[0]][0]:
                    self.newlines.append(self.lines[it])
                    if __name__ == '__main__':
                        print '\nCase 1:', self.lines[it]
                        print 'IT', str(it)
                        print 'category[0][0]', str(self.csections[category[0]][0])
                        print 'DEV[0]', str(self.csections[dev][0])
                        print 'DEV', str(dev)
                    it +=1
                else:#ALL GREATER THAN 0[0]
                    if category.index(dev) < len(category):#IF IT'S NOT THE LAST ITEM
                        if self.csections[dev][0] <= it <= self.csections[dev][1]:#NEW
                            if __name__ == '__main__':
                                print '\nCase 2:'
                                print 'IT', str(it), 'MIDIT', midit, 'LEN MIDIT', len(new[dev])
                                print 'DEV[0]', str(self.csections[dev][0])
                                print 'DEV[1]', str(self.csections[dev][1])
                                print 'DEV', str(dev)
                            
                            if midit <= len(new[dev]):
                                self.newlines.append(new[dev][midit])
                                if __name__ == '__main__':
                                    print 'NEW APPENDED (Case2)', new[dev][midit]
                                midit +=1
                                
                            else:
                                midit = 0
                            it +=1
                            
                        elif category.index(dev)+1 > len(category):
                            if self.csections[dev][1] <= it <= self.csections[category[category.index(dev)+1]][0]:#LIN
                                self.newlines.append(self.lines[it])
                                if __name__ == '__main__':
                                    print '\nCase 3:', self.lines[it]
                                    print 'IT', str(it), 'MIDIT', midit, 'LEN MIDIT', len(new[dev])
                                    print 'DEV[0]', str(self.csections[dev][0])
                                    print 'DEV[1]', str(self.csections[dev][1])
                                    print 'DEV', str(dev)
                                it +=1
                            else:#useless?
                                if __name__ == '__main__':
                                    print 'Vediamo Case 4:', str(category[category.index(dev)])
                                    print 'IT', it, 'MIDIT', midit, 'LEN MIDIT', len(new[dev])
                                    print 'DEV', str(dev)
                                self.newlines.append(self.lines[it])
                                it +=1
                                #print '\nCase 4:', self.lines[it]
                        else:
                            if it >= len(self.lines):
                                break
                            self.newlines.append(self.lines[it])
                            if __name__ == '__main__':
                                print '\nCase 5 (doesn\'t fit)', str(it), '\nline', str(self.lines[it])
                                print 'MIDIT', midit, 'LEN MIDIT', len(new[dev])
                                print 'DEV[0]', str(self.csections[dev][0])
                                print 'DEV[1]', str(self.csections[dev][1])
                                print 'DEV', str(dev)
                            #print 'NEXTDEV', str(self.csections[category[category.index(dev)+1]][0])
    ##                        category.index(category[0])
                            it +=1
                            midit = 0
                            if category.index(dev)+1 < len(category):
                                if self.csections[category[a]+1][0] <= it <= self.csections[category[a]+1][1]:
                                    a +=1
                                    dev = category[a]

    def rmoption(self, option, category):
        self.__init__()
        self.operate()
        if self.nofile == False:
            self.getdevice()
            self.getscreen()
            self.getmonitors()
            self.getextensions()
            self.getserverflags()
            self.getserverlayouts()
            if category == 'devices':
                self.addscreenoption(option, '', self.devices)
            elif category == 'screens':
                self.addscreenoption(option, '', self.screens)
            elif category == 'extensions':
                self.addscreenoption(option, '', self.extensions)
    ##        self.addscreenoption(option, '', category)
            if self.nocategory == False:
                file2 = open(self.file, 'w')
                file2.write(''.join(self.newlines))
                file2.close()
        else:
            print '\nENVY PARSER: No xorg.conf found.\n'
        
    def changeoption(self, option, newoption, category):
        '''
        This method removes the option according to a pattern ("option") which the option contains and adds a new option
        ("newoption")
        Arguments:
        option = a word which the said option to add/remove contains
        newoption = the complete line of the option
        category = either "screens" (modifies each Screen Section) or "devices" (modifies each Device Section)
        '''
        self.__init__()
        self.operate()
        if self.nofile == False:
##            self.getdevice()
##            self.getscreen()
##            self.getmonitors()
##            self.getextensions()
##            self.getserverflags()
##            self.getserverlayouts()
            self.rmoption(option, category)
            self.addoption(newoption, category)
        else:
            print '\nENVY PARSER: No xorg.conf found.\n'
    
    def addoption(self, option, category):
        self.__init__()
        self.operate()
        if self.nofile == False:
            self.getdevice()
            self.getscreen()
            self.getmonitors()
            self.getextensions()
            self.getserverflags()
            self.getserverlayouts()
            if category == 'devices':
                self.insscreenoption(option, self.devices)
            elif category == 'screens':
                self.insscreenoption(option, self.screens)
            elif category == 'monitors':
                self.insscreenoption(option, self.monitors)
            elif category == 'extensions':
                self.insscreenoption(option, self.extensions)
            elif category == 'serverflags':
                self.insscreenoption(option, self.serverflags)
            elif category == 'serverlayouts':
                self.insscreenoption(option, self.serverlayouts)
            if self.nocategory == False:
                file2 = open(self.file, 'w')
                file2.write(''.join(self.newlines))
                file2.close()
            elif self.nocategory == True:#if no extensions section is available, create it and run addoption again
                if category == 'extensions':
                    file2 = open(self.file, 'a')
                    file2.write('\nSection "Extensions"\nEndSection\n')
                    file2.close()
                    self.addoption(option, category)
        else:
            print '\nENVY PARSER: No xorg.conf found.\n'
        
        
    def parseoption(self, option, value, category):
        '''
        example:
        option = 'AddARGBGLXVisuals'
        value = 'True'
        category = 'screens'
        result:
        '\tOption\t\t"AddARGBGLXVisuals"\t"True"\n'
        '''
        self.changeoption(option, '\tOption\t\t"' + option + '"\t"' + value + '"\n', category)
        
    def enableoption(self, option, category):
        '''
        sets the desired option to "True"
        '''
        self.parseoption(option, 'True', category)
        
    def disableoption(self, option, category):
        '''it is usually a better idea to remove the option
        instead of disabling it
        '''
        self.parseoption(option, 'False', category)
        
    def customoption(self, option, value, category):
        '''
        example
        option = 'UseDisplayDevice'
        value = 'DFP'
        
        result:
        Option "UseDisplayDevice" "DFP"
        '''
        self.parseoption(option, value, category)

    
    def setdriver(self, new):
        '''
        USAGE:
        pass it the driver you wish to set as an argument.
        Example
        self.setdriver('nvidia')
        '''
        if not os.path.isfile(self.file):#NO XORG.conf FOUND
            self.nofile = True
            print '\nENVY PARSER: No xorg.conf found.\n'
        else:
            drvlst = ['fbdev', 'vga', 'vesa', 'radeon', 'ati', 'fglrx', 'nv', 'nvidia', 'radeonhd', 'nouveau']
            lines = []
            text = open(self.file, 'r')
            optext = text.readlines()
            pat1 = re.compile('(.*)Driver.*\"(.+)\".*\n')
            for line in optext:
                m1 = pat1.match(line)
                if m1:
                    if '#' not in m1.group(1).strip():#it must not be commented out
                        drvstring = m1.group(2).strip()
                        if drvstring in drvlst:
                            line = '\tDriver\t\t\"' + new + '\"\n'
                    lines.append(line)
                else:
                    lines.append(line)
            text.close()
            sep = ''
            modtext = open(self.file, 'w')
            a = sep.join(lines)
            modtext.write(a)
            modtext.close()

    def drivercheck(self):
        #self.file = '/etc/X11/xorg.conf'
        driver = None
        drvlst = ['fglrx', 'nvidia']
        drvs = []
        text = open(self.file, 'r')
        optext = text.readlines()
        pat1 = re.compile('(.*)Driver.*\"(.+)\".*\n')
        for line in optext:
            m1 = pat1.match(line)
            if m1:
                if '#' not in m1.group(1).strip():
                    drvstring = m1.group(2).strip()
                    if drvstring in drvlst:
                        drvs.append(drvstring)
                        print 'ENVY: ' + drvstring + ' driver previously installed'
        text.close()
        if len(drvs) > 0:
            #driver = drvs[0]
            if 'fglrx' in drvs:
                newdrv = 'vesa'
                print 'ENVY: setting the driver to ' + newdrv
            elif 'nvidia' in drvs:
                newdrv = 'nv'
                print 'ENVY: setting the driver to ' + newdrv
            elif 'fglrx' in drvs and'nvidia' in drvs:
                newdrv = 'vesa'
                print 'ENVY: setting the driver to ' + newdrv


    def enablecomposite(self):
        self.customoption('Composite', 'Enable', 'extensions')

    def disablecomposite(self):
        self.customoption('Composite', 'Disable', 'extensions')
        
    def addargbglxvisuals(self):
        self.rmoption('AddARGBGLXVisuals', 'devices')
        self.enableoption('AddARGBGLXVisuals', 'screens')

    def videooverlayon(self):
        self.customoption('VideoOverlay', 'on', 'devices')
    
    def opengloverlayoff(self):
        self.customoption('OpenGLOverlay', 'off', 'devices')
        
    def usedisplaydevicedfp(self):
        self.customoption('UseDisplayDevice', 'DFP', 'screens')

    def removealloptions(self):
        self.rmoption('Composite', 'extensions')
        self.rmoption('AddARGBGLXVisuals', 'screens')
        self.rmoption('UseDisplayDevice', 'screens')
        self.rmoption('VideoOverlay', 'devices')
        self.rmoption('OpenGLOverlay', 'devices')

        

'''
Examples:
a.changeoption('AddARGBGLXVisuals', '\tOption\t\t"AddARGBGLXVisuals"\t"True"\n', 'screens')
a.rmoption('AddARGB', 'devices')
a.rmoption('AddARGB', 'screens')
a.changeoption('AddARGBGLXVisuals', '\tOption\t\t"AddARGBGLXVisuals"\t"True"\n', 'screens')
a.customoption('UseDisplayDevice', 'DFP', 'screens')
a.customoption('Composite', 'Disable', 'extensions')
a.setdriver('nvidia')
'''




if __name__ == '__main__':
    print 'Envy Parser:\n'
    a = EnvyParser()
    a.operate()
    a.getdevice()
    a.getscreen()
    a.getmonitors()
    a.getextensions()
    a.getserverflags()
    a.getserverlayouts()
    #a.disablecomposite()
    #a.rmoption('VideoOverlay', 'devices')
